import org.jfugue.*;
import org.jfugue.extras.IntervalPatternTransformer;

//----------------------------- Ending -----------------------------------------
public class Ending {
    public Pattern pattern = new Pattern();

    //----------------------------- Constructor --------------------------------
    //  Generate a song ending and transpose to the correct key
    //  Parameters: Melody Voice, Bassline Voice, Harmony Voice, Rhythm Voice,
    //              Amount to  Transpose Endong
    //-------------------------------------------------------------------------
    public Ending(String melodyVoicePR, String bassVoicePR, String harmonyVoicePR, String rhythmVoicePR,
                  int transPR) {

        Pattern mPat = new Pattern("V4 I[" + melodyVoicePR + "] C6majw ");
        Pattern hPat = new Pattern("V3 I[" + harmonyVoicePR + "] C5w ");
        Pattern bPat = new Pattern("V2 I[" + bassVoicePR + "] C3w ");
        Pattern rPat = new Pattern("V0 I[" + rhythmVoicePR + "] C4majw ");

        pattern.add(rPat);
        pattern.add(bPat);
        pattern.add(hPat);
        pattern.add(mPat);
        
        IntervalPatternTransformer transposer = new IntervalPatternTransformer(transPR);
        pattern = transposer.transform(pattern);
        
    }//ending
}
