import org.jfugue.*;

//----------------------------- Class::Harmony --------------------------------
public class Harmony {
    private MusicToolbox mtoolbox = new MusicToolbox();
    public Pattern pattern = new Pattern();

    //----------------------------- Constructor --------------------------------
    //  Generates a harmony based on a given rhythm
    //  Parameters:  Number of Chord Loops, Voice, Number of pitches in Rhythm,
    //               Chord Progression, Beat Type, Number of Beats,
    //               Rhythm String, octavePR of Harmony, Voice Number,
    //               Genetic Code
    //-------------------------------------------------------------------------
    public Harmony(int numChordLoopsPR, String voicePR, int numrhythmNotesPR,
                    String[] chordProgPR, char beatTypePR, int numBeatsPR,
                    String[] rhythmPR, String octavePR, int vNumPR,
                    SongGeneticCode chromosomePR) {
        //initialize variables and add header to the harmony string
        int j=0;
        String svNum = Integer.toString(vNumPR);
        int notesLeft = mtoolbox.getNum16ths(beatTypePR, numBeatsPR);
        String hString = "V" + svNum + " I[" + voicePR + "] ";

        //for each note in the rhythm add an arrpegio note to the
        //harmony string of the same duration
        for(int i=0; i<numrhythmNotesPR; i++) {
          hString += mtoolbox.getArpeggioNote(chordProgPR[j], chromosomePR.ArpeggioChrom) + octavePR + rhythmPR[i] + " ";

          if (rhythmPR[i].equals("w")) notesLeft -= 16;
          if (rhythmPR[i].equals("h")) notesLeft -= 8;
          if (rhythmPR[i].equals("q")) notesLeft -= 4;
          if (rhythmPR[i].equals("i")) notesLeft -= 2;
          if (rhythmPR[i].equals("s")) notesLeft -= 1;
          if(notesLeft==0) {
            j++;
            notesLeft = mtoolbox.getNum16ths(beatTypePR, numBeatsPR);
          }
      }//for each rhythm

      //use harmony string to generate pattern
      pattern = new Pattern(hString);
      pattern.repeat(numChordLoopsPR);
    }//constructor

    
}
