//----------------------------- class:MusicToolbox -----------------------------
// Constains useful functions that are called by a variety of the program's classes
//------------------------------------------------------------------------------
public class MusicToolbox {


    //----------------------------- Constructor --------------------------------
    public MusicToolbox() { }

    //----------------------------- getNumber16ths --------------------------------
    //  Returns the number of 16th notes in a measure based on the
    //  time signature
    //  Parameters:  Beat Type, Number of Beats
    //-------------------------------------------------------------------------
    public int getNum16ths(char beatTypePR, int numBeatsPR) {
      if (beatTypePR=='h') return 8*numBeatsPR;
      if (beatTypePR=='q') return 4*numBeatsPR;
      if (beatTypePR=='i') return 2*numBeatsPR;
      else return numBeatsPR;
    }

    //----------------------------- getNextPitch --------------------------------
    //  Returns the number of 16th notes in a given type of beat
    //  Parameters:  Beat Type
    //-------------------------------------------------------------------------
    public int getNum16ths(char beatTypePR) {
      if (beatTypePR=='w') return 16;
      if (beatTypePR=='h') return 8;
      if (beatTypePR=='q') return 4;
      if (beatTypePR=='i') return 2;
      else return 0;
    }

    //----------------------------- noteToInterval --------------------------------
    //  Returns the interval of a note given the root
    //  Parameters:  Root Note, Note of Interval
    //-------------------------------------------------------------------------
    public int noteToInterval(char rootPR, char notePR) {
       if (rootPR=='C') {
          if (notePR=='D') return 2;
          if (notePR=='E') return 3;
          if (notePR=='F') return 4;
          if (notePR=='G') return 5;
          if (notePR=='A') return 6;
          if (notePR=='B') return 7;
      }
      if (rootPR=='D') {
          if (notePR=='E') return 2;
          if (notePR=='F') return 3;
          if (notePR=='G') return 4;
          if (notePR=='A') return 5;
          if (notePR=='B') return 6;
          if (notePR=='C') return 7;
      }
      if (rootPR=='E') {
          if (notePR=='F') return 2;
          if (notePR=='G') return 3;
          if (notePR=='A') return 4;
          if (notePR=='B') return 5;
          if (notePR=='C') return 6;
          if (notePR=='D') return 7;
      }
      if (rootPR=='F') {
          if (notePR=='G') return 2;
          if (notePR=='A') return 3;
          if (notePR=='B') return 4;
          if (notePR=='C') return 5;
          if (notePR=='D') return 6;
          if (notePR=='E') return 7;
      }
      if (rootPR=='G') {
          if (notePR=='A') return 2;
          if (notePR=='B') return 3;
          if (notePR=='C') return 4;
          if (notePR=='D') return 5;
          if (notePR=='E') return 6;
          if (notePR=='F') return 7;
      }
      if (rootPR=='A') {
          if (notePR=='B') return 2;
          if (notePR=='C') return 3;
          if (notePR=='D') return 4;
          if (notePR=='E') return 5;
          if (notePR=='F') return 6;
          if (notePR=='G') return 7;
      }
      if (rootPR=='B') {
          if (notePR=='C') return 2;
          if (notePR=='D') return 3;
          if (notePR=='E') return 4;
          if (notePR=='F') return 5;
          if (notePR=='G') return 6;
          if (notePR=='A') return 7;
      }
      return 1;
    }

    //----------------------------- intervalToNote --------------------------------
    //  Returns the note represented by a given interval based on the root note
    //  Parameters:  Root Note, Interval
    //-------------------------------------------------------------------------
    public String intervalToNote(char rootPR, int intervalPR) {
      if (rootPR=='C') {
          if (intervalPR==2) return "D";
          if (intervalPR==3) return "E";
          if (intervalPR==4) return "F";
          if (intervalPR==5) return "G";
          if (intervalPR==6) return "A";
          if (intervalPR==7) return "B";
      }
      if (rootPR=='D') {
          if (intervalPR==2) return "E";
          if (intervalPR==3) return "F";
          if (intervalPR==4) return "G";
          if (intervalPR==5) return "A";
          if (intervalPR==6) return "B";
          if (intervalPR==7) return "C";
      }
      if (rootPR=='E') {
          if (intervalPR==2) return "F";
          if (intervalPR==3) return "G";
          if (intervalPR==4) return "A";
          if (intervalPR==5) return "B";
          if (intervalPR==6) return "C";
          if (intervalPR==7) return "D";
      }
      if (rootPR=='F') {
          if (intervalPR==2) return "G";
          if (intervalPR==3) return "A";
          if (intervalPR==4) return "B";
          if (intervalPR==5) return "C";
          if (intervalPR==6) return "D";
          if (intervalPR==7) return "E";
      }
      if (rootPR=='G') {
          if (intervalPR==2) return "A";
          if (intervalPR==3) return "B";
          if (intervalPR==4) return "C";
          if (intervalPR==5) return "D";
          if (intervalPR==6) return "E";
          if (intervalPR==7) return "F";
      }
      if (rootPR=='A') {
          if (intervalPR==2) return "B";
          if (intervalPR==3) return "C";
          if (intervalPR==4) return "D";
          if (intervalPR==5) return "E";
          if (intervalPR==6) return "F";
          if (intervalPR==7) return "G";
      }
      if (rootPR=='B') {
          if (intervalPR==2) return "C";
          if (intervalPR==3) return "D";
          if (intervalPR==4) return "E";
          if (intervalPR==5) return "F";
          if (intervalPR==6) return "G";
          if (intervalPR==7) return "A";
      }
      return "C";
  }

    //----------------------------- getNextPitch --------------------------------
    //  Returns a note of an arpeggio based on a chord and the arpeggio
    //  chromosome
    //  Parameters:  Chord, Chromosome
    //-------------------------------------------------------------------------
    public String getArpeggioNote(String chordPR, Chromosome chromosomePR) {
        int i = chromosomePR.getNextAlleleValue()%3;
        if (i==0) i=1;
        else if(i==1) i=3;
        else if (i==2) i=5;
        return intervalToNote(chordPR.charAt(0), i);
    }

    //----------------------------- getNextPitchInScale --------------------------------
    //  Returns the next pitch in the scale
    //  Parameters:  Current Pitch, Scale
    //-------------------------------------------------------------------------
    public String getNextPitchInScale(String cPitchPR, String scalePR) {
      String nextNote = new String();
      int cOctave = Character.digit(cPitchPR.charAt(1), 10);
      int nOctave;
      if(cOctave!=10) nOctave = cOctave+1;
      else nOctave = cOctave;
      
      if (scalePR.equals("pentatonic")) {
        if (cPitchPR.charAt(0)=='A') nextNote="C" + Integer.toString(nOctave);
        if (cPitchPR.charAt(0)=='B') nextNote="C" + Integer.toString(nOctave);
        if (cPitchPR.charAt(0)=='C') nextNote="D" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='D') nextNote="E" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='E') nextNote="G" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='F') nextNote="G" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='G') nextNote="A" + Integer.toString(cOctave);
      }
      if (scalePR.equals("major")) {
        if (cPitchPR.charAt(0)=='A') nextNote="B" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='B') nextNote="C" + Integer.toString(nOctave);
        if (cPitchPR.charAt(0)=='C') nextNote="D" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='D') nextNote="E" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='E') nextNote="F" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='F') nextNote="G" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='G') nextNote="A" + Integer.toString(cOctave);
      }

      return nextNote;
  }

    //----------------------------- getPrevPitchInScale --------------------------------
    //  Returns the prevoius pitch in the scale
    //  Parameters:  Current Pitch, Scale
    //-------------------------------------------------------------------------
    public String getPrevPitchInScale(String cPitchPR, String scalePR) {
      String nextNote = new String();
      int cOctave = Character.digit(cPitchPR.charAt(1), 10);
      int pOctave;
      if(cOctave!=0) pOctave = cOctave-1;
      else pOctave = cOctave;

      if (scalePR.equals("pentatonic")) {
        if (cPitchPR.charAt(0)=='A') nextNote="G" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='B') nextNote="A" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='C') nextNote="A" + Integer.toString(pOctave);
        if (cPitchPR.charAt(0)=='D') nextNote="C" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='E') nextNote="D" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='F') nextNote="E" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='G') nextNote="F" + Integer.toString(cOctave);
      }
      if (scalePR.equals("major")) {
        if (cPitchPR.charAt(0)=='A') nextNote="G" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='B') nextNote="A" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='C') nextNote="B" + Integer.toString(pOctave);
        if (cPitchPR.charAt(0)=='D') nextNote="C" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='E') nextNote="D" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='F') nextNote="E" + Integer.toString(cOctave);
        if (cPitchPR.charAt(0)=='G') nextNote="F" + Integer.toString(cOctave);
      }

      return nextNote;
  }

    //----------------------------- isArpeggio --------------------------------
    //  Returns true if the given note is a arpeggio with respect to the root
    //  Parameters:  Root Note, Note
    //-------------------------------------------------------------------------
    public Boolean isArpeggio(char rootPR, char notePR) {
      if (noteToInterval(rootPR, notePR)==1 ||
          noteToInterval(rootPR, notePR)==3 ||
          noteToInterval(rootPR, notePR)==5) return true;

      return false;
   }

}
