import javax.swing.*;
import java.io.*;
import java.awt.event.*;

/*
 * Open Song Composer (c) 2010
 * Author: Nathan L. Fortier
 */

//----------------------------- Class:gui -----------------------------
public class gui extends javax.swing.JFrame {

    static Population pop = new Population();
    static SongGeneticCode code;
    static fitnessGUI fg = new fitnessGUI();

    //Listens for timer and uodates fitness if it has been set
    public static class tListener implements ActionListener {
         public void actionPerformed(ActionEvent event) {

           if (fg.fitness>-1) {
             //save fitness and genetic code
             //to file and population
             code.fitness = fg.fitness;
             pop.offerMember(code);
             pop.save();
             fg = new fitnessGUI();
           }//if fitness has been set
         }
    }

    /** Creates new form gui */
    public gui() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        goButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Open Song Composer");

        goButton.setText("Generate song and save as midi");
        goButton.setMaximumSize(new java.awt.Dimension(83, 23));
        goButton.setMinimumSize(new java.awt.Dimension(83, 23));
        goButton.setPreferredSize(new java.awt.Dimension(83, 23));
        goButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                goButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(goButton, javax.swing.GroupLayout.DEFAULT_SIZE, 312, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(goButton, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void goButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_goButtonActionPerformed
       JFileChooser fc = new JFileChooser();
       fc.showSaveDialog(null);
       
       if (fc.getSelectedFile()!=null) {
         File file = fc.getSelectedFile();  

         //get genetic code from population and
         //generate/save the song.
         code = pop.getCode();
         Generator gen = new Generator(code);
         gen.generateSong(file);

         //show fitness gui
         fg.setVisible(true);
       }//if user selected a file

    }//GEN-LAST:event_goButtonActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                //load the population
                pop.load();
                //setup timer and listener to check if fitness has been set
                ActionListener l = new tListener();
                Timer t = new Timer(100, l);
                t.start();
                new gui().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton goButton;
    // End of variables declaration//GEN-END:variables

}
